# gradientchat
`gradientchat` is the official Python bot client module for GradientChat ~~that is OOP-based~~.
## Example
### TestBot
```py
import gradientchat

myBot = gradientchat.Bot("TestBot [t!]") # No prefix arg makes prefix first letter of name + "!"

@myBot.cmd
def ping():
	"""Returns \"Pong!\"""" # Docstring is used as description for the command
	return "Pong!"

myBot.connect()
```
## Docs
### `gradientchat.Bot(name, pref)`
If `name` is not `str`, raises `TypeError`, however if `pref` is not string and `name` is `str`, prefix will be lowercase of first character of `name` and a exclamation mark.
### `gradientchat.Bot.connect(servUrl)`
Connects to server; if `servUrl` is `str`, connects to URL specified on `servUrl`; raises `Exception` if already connected.
### `@gradientchat.Bot.cmd`
Decorator for adding a command; if called with a command name, command name will be set to the specified command name.
### `gradientchat.Bot.sendMsg`
Sends a message.